# 1. Create directory "samples" to your Gitlab repository and add one sample to it
# 2. Replace <SAMPLE> and <VIRUSTOTAL API KEY> placeholders
---

resources:

- name: workspace-git-repo
  type: git
  source:
    branch: master
    uri: ((samples-uri)) 
    private_key: ((samples-private-key))

- name: identify-docker-image
  type: docker-image
  source: {repository: cincan/identify-file, tag: latest}

- name: pe-docker-image
  type: docker-image
  source: {repository: cincan/pe-scanner, tag: latest}

- name: strings-docker-image
  type: docker-image
  source: {repository: cincan/static-analysis, tag: latest}

- name: cortex-docker-image
  type: docker-image
  source: {repository: cincan/cortex, tag: latest}

jobs:

- name: identify-file
  serial: true
  plan:
  - get: workspace-git-repo
  - get: identify-docker-image

  - task: identify-file
    image: identify-docker-image
    config:
      platform: linux
      inputs:
        - name: workspace-git-repo
      outputs:
        - name: trid
      run:
        path: sh
        args:
        - -exc
        - |
          for f in workspace-git-repo/samples/*; do echo $f && /usr/bin/python /build/entrypoint.py $f >> trid/${f##*/}_identify_file; done
          for f in trid/*; do echo $f && cat $f; done

  - task: commit-repo
    image: identify-docker-image
    config:
      platform: linux
      inputs:
        - name: workspace-git-repo
        - name: trid
      outputs:
        - name: updated-git-repo
      run:
        path: sh
        args:
        - -exc
        - |
          git clone workspace-git-repo updated-git-repo
          cp -r trid updated-git-repo
          git config --global user.name "user"
          git config --global user.email "user@concourse"
          cd updated-git-repo  
          git add .
          git commit -a -m "identify-file results"

  - put: workspace-git-repo
    params: {repository: updated-git-repo}

- name: pe-scanner & strings
  serial: true
  plan:
  - get: workspace-git-repo
    passed: [identify-file]
    trigger: true
  - get: pe-docker-image
  - get: strings-docker-image
  - task: pe-scanner
    image: pe-docker-image
    config:
      platform: linux
      inputs:
        - name: workspace-git-repo
      outputs:
        - name: pe-scanner
      run:
        path: sh
        args:
        - -exc
        - |
          for f in workspace-git-repo/samples/*; do echo $f && /usr/bin/python /build/entrypoint.py $f >> pe-scanner/${f##*/}_pe_scanner; done
          for f in pe-scanner/*; do echo $f && cat $f; done

  - task: strings
    image: strings-docker-image
    config:
      platform: linux
      inputs:
        - name: workspace-git-repo
        - name: pe-scanner
      outputs:
        - name: strings
      run:
        path: sh
        args:
        - -exc
        - |
          for f in workspace-git-repo/samples/*; do echo $f && /usr/bin/strings $f >> strings/${f##*/}_strings; done
          for f in strings/*; do echo $f && cat $f; done

  - task: commit-repo
    image: pe-docker-image
    config:
      platform: linux
      inputs:
        - name: workspace-git-repo
        - name: pe-scanner
        - name: strings
      outputs:
        - name: updated-git-repo
      run:
        path: sh
        args:
        - -exc
        - |
          git clone workspace-git-repo updated-git-repo
          cp -r pe-scanner updated-git-repo
          cp -r strings updated-git-repo
          git config --global user.name "user"
          git config --global user.email "user@concourse"
          cd updated-git-repo
          git add .
          git commit -a -m "pe-scanner and strings results"

  - put: workspace-git-repo
    params: {repository: updated-git-repo}

- name: cortex-results
  serial: true
  plan:
  - get: workspace-git-repo
    passed: [pe-scanner & strings]
    trigger: true
  - get: cortex-docker-image
  - task: cortex-results
    image: cortex-docker-image
    config:
      platform: linux
      inputs:
        - name: workspace-git-repo
      outputs:
        - name: cortex
      run:
        path: sh
        args: 
        - -exc
        - |
          for f in workspace-git-repo/trid/* workspace-git-repo/pe-scanner/*; do echo $f && /usr/bin/python /build/cortex/cortex_tool.py $f cortex/${f##*/}_cortex_json <SAMPLE> "<VIRUSTOTAL API KEY>"; done
          for f in cortex/*; do echo $f && cat $f; done

  - task: commit-repo
    image: cortex-docker-image
    config:
      platform: linux
      inputs:
        - name: workspace-git-repo
        - name: cortex
      outputs:
        - name: updated-git-repo
      run:
        path: sh
        args:
        - -exc
        - |
          git clone workspace-git-repo updated-git-repo
          cp -r cortex updated-git-repo
          git config --global user.name "user"
          git config --global user.email "user@concourse"
          cd updated-git-repo
          git add .
          git commit -a -m "virustotal cortex results"

  - put: workspace-git-repo
    params: {repository: updated-git-repo}

